Statistics
| Branch: | Revision:

root / create @ e34560c8

History | View | Annotate | Download (5.5 kB)

1 79224631 Lance Albertson
#!/bin/bash
2 79224631 Lance Albertson
3 f1afb4b1 Lance Albertson
# Copyright (C) 2010 Oregon State University
4 79224631 Lance Albertson
#
5 79224631 Lance Albertson
# This program is free software; you can redistribute it and/or modify
6 79224631 Lance Albertson
# it under the terms of the GNU General Public License as published by
7 79224631 Lance Albertson
# the Free Software Foundation; either version 2 of the License, or
8 79224631 Lance Albertson
# (at your option) any later version.
9 79224631 Lance Albertson
#
10 79224631 Lance Albertson
# This program is distributed in the hope that it will be useful, but
11 79224631 Lance Albertson
# WITHOUT ANY WARRANTY; without even the implied warranty of
12 79224631 Lance Albertson
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
13 79224631 Lance Albertson
# General Public License for more details.
14 79224631 Lance Albertson
#
15 79224631 Lance Albertson
# You should have received a copy of the GNU General Public License
16 79224631 Lance Albertson
# along with this program; if not, write to the Free Software
17 79224631 Lance Albertson
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
18 79224631 Lance Albertson
# 02110-1301, USA.
19 79224631 Lance Albertson
20 79224631 Lance Albertson
set -e
21 79224631 Lance Albertson
22 6f0a1fef Lance Albertson
. common.sh
23 6f0a1fef Lance Albertson
24 e7a2d1ad Lance Albertson
debug set -x
25 e84e87cd Lance Albertson
26 5dc61974 Nikos Skalkotos
OS_FAMILY="linux"
27 5dc61974 Nikos Skalkotos
28 baca98f3 Lance Albertson
if [ "$IMAGE_TYPE" = "tarball" ] ; then
29 baca98f3 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.tar.gz"
30 baca98f3 Lance Albertson
elif [ "$IMAGE_TYPE" = "qemu" ] ; then
31 baca98f3 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.img"
32 640e7e45 Lance Albertson
elif [ "$IMAGE_TYPE" = "dump" ] ; then
33 640e7e45 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}-root.dump"
34 e34560c8 Nikos Skalkotos
    # Workaround for restore's non-unique /tmp/rstdir* and /tmp/rstmode* 
35 e34560c8 Nikos Skalkotos
    export TMPDIR=$(mktemp -d /tmp/${INSTANCE_NAME}_XXXXXXXX)
36 e34560c8 Nikos Skalkotos
    CLEANUP+=("rmdir --ignore-fail-on-non-empty $TMPDIR")
37 a33d2ab2 Nikos Skalkotos
elif [ "$IMAGE_TYPE" = "ntfsclone" ]; then
38 a33d2ab2 Nikos Skalkotos
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.img"
39 a33d2ab2 Nikos Skalkotos
    OS_FAMILY="windows"
40 baca98f3 Lance Albertson
fi
41 134c11c3 Lance Albertson
42 58453ea9 Nikos Skalkotos
MONITOR="" #Empty if progress monitor support is disabled
43 d55a2cc1 Nikos Skalkotos
if [ "$progress_monitor_support" = "yes" ]; then
44 58453ea9 Nikos Skalkotos
    IMAGE_SIZE="$(stat -L -c %s ${IMAGE_FILE})"
45 58453ea9 Nikos Skalkotos
    MONITOR="$PROGRESS_MONITOR -i ${INSTANCE_NAME} -r ${IMAGE_SIZE}"
46 58453ea9 Nikos Skalkotos
fi
47 58453ea9 Nikos Skalkotos
48 a33d2ab2 Nikos Skalkotos
if [ "$OS_FAMILY" = "linux" ]; then
49 a33d2ab2 Nikos Skalkotos
    . common_linux.sh
50 a33d2ab2 Nikos Skalkotos
elif [ "$OS_FAMILY" = "windows" ]; then
51 a33d2ab2 Nikos Skalkotos
    . common_windows.sh
52 a33d2ab2 Nikos Skalkotos
    SWAP="no"
53 a33d2ab2 Nikos Skalkotos
fi
54 5dc61974 Nikos Skalkotos
55 fcce5224 Lance Albertson
if [ "$CDINSTALL" = "no" ] ; then
56 fcce5224 Lance Albertson
    # If the target device is not a real block device we'll first losetup it.
57 fcce5224 Lance Albertson
    # This is needed for file disks.
58 fcce5224 Lance Albertson
    if [ ! -b $blockdev ]; then
59 fcce5224 Lance Albertson
      ORIGINAL_BLOCKDEV=$blockdev
60 fcce5224 Lance Albertson
      blockdev=$($LOSETUP -sf $blockdev)
61 fcce5224 Lance Albertson
      CLEANUP+=("$LOSETUP -d $blockdev")
62 fcce5224 Lance Albertson
    fi
63 fcce5224 Lance Albertson
64 b05b1ab6 Lance Albertson
    if [ ! -f "$IMAGE_FILE" ] ; then
65 b05b1ab6 Lance Albertson
      log_error "Can't find image file: $IMAGE_FILE"
66 b05b1ab6 Lance Albertson
      exit 1
67 b05b1ab6 Lance Albertson
    fi
68 b05b1ab6 Lance Albertson
69 b05b1ab6 Lance Albertson
    # If the image is tarball based, then we need to manually create the
70 b05b1ab6 Lance Albertson
    # volumes, filesystems, etc
71 640e7e45 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" -o "${IMAGE_TYPE}" = "dump" ] ; then
72 b05b1ab6 Lance Albertson
        # Create 3 partitions, /boot, swap, & /
73 bb78ba49 Nikos Skalkotos
        ${OS_FAMILY}_format_disk0 $blockdev
74 b05b1ab6 Lance Albertson
    elif [ "${IMAGE_TYPE}" = "qemu" ] ; then
75 b05b1ab6 Lance Albertson
        # need a recent version of qemu for this
76 78422bb3 Lance Albertson
        ${QEMU_IMG} convert ${IMAGE_FILE} -O host_device ${blockdev} > /dev/null
77 a33d2ab2 Nikos Skalkotos
    elif [ "${IMAGE_TYPE}" = "ntfsclone" ] ; then
78 a33d2ab2 Nikos Skalkotos
        ${OS_FAMILY}_format_disk0 $blockdev
79 b05b1ab6 Lance Albertson
    fi
80 b05b1ab6 Lance Albertson
81 8727c57d Lance Albertson
    # deploying something like a windows image, skip the rest
82 8727c57d Lance Albertson
    if [ "${NOMOUNT}" = "yes" ] ; then
83 8727c57d Lance Albertson
      cleanup
84 8727c57d Lance Albertson
      exit 0
85 8727c57d Lance Albertson
    fi
86 8727c57d Lance Albertson
87 494927a8 Lance Albertson
    filesystem_dev=$(map_disk0 $blockdev)
88 a1d43218 Lance Albertson
    CLEANUP+=("unmap_disk0 $blockdev")
89 494927a8 Lance Albertson
    root_dev=$(map_partition $filesystem_dev root)
90 494927a8 Lance Albertson
    boot_dev=$(map_partition $filesystem_dev boot)
91 494927a8 Lance Albertson
    swap_dev=$(map_partition $filesystem_dev swap)
92 fcce5224 Lance Albertson
93 e9568fe9 Nikos Skalkotos
    # Check partition existence
94 e9568fe9 Nikos Skalkotos
    if [ ! -e "$root_dev" ] ; then
95 e9568fe9 Nikos Skalkotos
        log_error "Root partition: $root_dev does not exist!"
96 e9568fe9 Nikos Skalkotos
        exit 1;
97 e9568fe9 Nikos Skalkotos
    fi
98 025dd949 Nikos Skalkotos
    if [ -n "$boot_dev" -a ! -e "$boot_dev" ] ; then
99 e9568fe9 Nikos Skalkotos
        log_error "Boot partition: $boot_dev does not exist!"
100 e9568fe9 Nikos Skalkotos
        exit 1;
101 e9568fe9 Nikos Skalkotos
    fi
102 025dd949 Nikos Skalkotos
    if [ -n "$swap_dev" -a ! -e "$swap_dev" ] ; then
103 e9568fe9 Nikos Skalkotos
        log_error "Swap partiion: $swap_dev does not exist!"
104 e9568fe9 Nikos Skalkotos
        exit 1;
105 e9568fe9 Nikos Skalkotos
    fi
106 e9568fe9 Nikos Skalkotos
107 640e7e45 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" -o "${IMAGE_TYPE}" = "dump" ] ; then
108 bb78ba49 Nikos Skalkotos
        ${OS_FAMILY}_mkfs_disk0
109 3903b7f1 Lance Albertson
        root_uuid="$($VOL_ID $root_dev)"
110 b8a540bb Lance Albertson
        [ -n "$boot_dev" ] && sleep 1 && boot_uuid="$($VOL_ID $boot_dev)"
111 b8a540bb Lance Albertson
        [ -n "$swap_dev" ] && sleep 1 && swap_uuid="$($VOL_ID $swap_dev)"
112 b05b1ab6 Lance Albertson
    fi
113 fcce5224 Lance Albertson
114 916b6dd1 Lance Albertson
    TARGET=`mktemp -d` || exit 1
115 916b6dd1 Lance Albertson
    CLEANUP+=("rmdir $TARGET")
116 fcce5224 Lance Albertson
117 a33d2ab2 Nikos Skalkotos
    if [ "${IMAGE_TYPE}" = "ntfsclone" ] ; then
118 59aff5e7 Nikos Skalkotos
        # Restore the ntfs image
119 58453ea9 Nikos Skalkotos
        $MONITOR $NTFSCLONE --restore-image --overwrite $root_dev $IMAGE_FILE \
120 58453ea9 Nikos Skalkotos
            > /dev/null
121 59aff5e7 Nikos Skalkotos
        # Resize it to take over the whole patition
122 59aff5e7 Nikos Skalkotos
        $NTFSRESIZE -P $root_dev
123 59aff5e7 Nikos Skalkotos
124 a33d2ab2 Nikos Skalkotos
    fi
125 a33d2ab2 Nikos Skalkotos
126 a1d43218 Lance Albertson
    # mount filesystems
127 77449e7c Lance Albertson
    mount_disk0 $TARGET
128 b05b1ab6 Lance Albertson
129 b05b1ab6 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" ] ; then
130 b05b1ab6 Lance Albertson
        # unpack image
131 916b6dd1 Lance Albertson
        tar pzxf $IMAGE_FILE -C $TARGET
132 640e7e45 Lance Albertson
    elif [ "${IMAGE_TYPE}" = "dump" ] ; then
133 0d9031a6 Lance Albertson
        root_dump="${IMAGE_FILE}"
134 58453ea9 Nikos Skalkotos
        ( cd ${TARGET}; $MONITOR $RESTORE -r -y -f ${root_dump} > /dev/null )
135 77449e7c Lance Albertson
136 77449e7c Lance Albertson
        if [ -n "${boot_dev}" ] ; then
137 77449e7c Lance Albertson
            boot_dump="${IMAGE_FILE/root.dump/boot.dump}"
138 77449e7c Lance Albertson
            if [ ! -f "$boot_dump" ] ; then
139 77449e7c Lance Albertson
              log_error "Can't find image file: $boot_dump"
140 77449e7c Lance Albertson
              exit 1
141 77449e7c Lance Albertson
            fi
142 8afaedb3 Nikos Skalkotos
            ( cd ${TARGET}/boot; $RESTORE -r -y -f ${boot_dump} > /dev/null )
143 77449e7c Lance Albertson
        fi
144 b05b1ab6 Lance Albertson
    fi
145 e5ec11e4 Lance Albertson
146 3903b7f1 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" -o "${IMAGE_TYPE}" = "dump" ] ; then
147 bb78ba49 Nikos Skalkotos
        ${OS_FAMILY}_setup_fstab $TARGET
148 3903b7f1 Lance Albertson
    fi
149 3903b7f1 Lance Albertson
150 9f4b2c31 Lance Albertson
    if [ "${INSTANCE_HV_serial_console}" = "True" ] ; then
151 bb78ba49 Nikos Skalkotos
        ${OS_FAMILY}_setup_console $TARGET
152 9f4b2c31 Lance Albertson
    fi
153 9f4b2c31 Lance Albertson
154 86ddc018 Nikos Skalkotos
    ${OS_FAMILY}_epilogue $TARGET
155 47e547ca Nikos Skalkotos
156 fcce5224 Lance Albertson
    RUN_PARTS=`which run-parts`
157 fcce5224 Lance Albertson
158 bb78ba49 Nikos Skalkotos
    if [ -n "$RUN_PARTS" -a -n "$CUSTOMIZE_DIR" -a -d "${CUSTOMIZE_DIR}/$OS_FAMILY" ]; then
159 916b6dd1 Lance Albertson
      TARGET=$TARGET
160 fcce5224 Lance Albertson
      BLOCKDEV=$blockdev
161 f7959feb Lance Albertson
      ROOT_DEV=$root_dev
162 c29e092d Lance Albertson
      BOOT_DEV=$boot_dev
163 ab462591 Constantinos Venetsanopoulos
      IMG_PASSWD=$IMG_PASSWD
164 8d77389f Nikos Skalkotos
      HOSTNAME=$instance
165 8d77389f Nikos Skalkotos
      export TARGET SUITE BLOCKDEV ROOT_DEV BOOT_DEV IMAGE_TYPE IMG_PASSWD HOSTNAME
166 bb78ba49 Nikos Skalkotos
      $RUN_PARTS $CUSTOMIZE_DIR/$OS_FAMILY
167 fcce5224 Lance Albertson
    fi
168 79224631 Lance Albertson
fi
169 79224631 Lance Albertson
170 79224631 Lance Albertson
# execute cleanups
171 79224631 Lance Albertson
cleanup
172 79224631 Lance Albertson
trap - EXIT
173 79224631 Lance Albertson
174 79224631 Lance Albertson
exit 0